MorethurQuickUse_BagNo = {};
MorethurQuickUse_SlotNo = {};
MorethurQuickUse_ItemCount = 0;
BINDING_HEADER_MORETHURQUICKUSEHEADER = "MorethurQuickUse";

function MQU_initialize()
	-- add our very first chat command!
	SlashCmdList["MQU"] = MQU_command;
	SLASH_MQU1 = "/mqu";

	DEFAULT_CHAT_FRAME:AddMessage("MorethurQuickUse Loaded");
	
	MorethurQuickUseTitle:SetText("QuickUse");	
	
	MQU_HideButtons();

	MQU_UpdateButtons();

	--this:Show()
end

function MQU_command(msg)
	-- this function handles our chat command
	--message(msg);
end

function MQU_HideButtons()
	for i = 1, 30, 1 do
		local button = getglobal("MorethurQuickUseButton" .. i);
		button:Hide();
	end
end


function MQU_ShowButtonTooltip()
	--GameTooltip:SetOwner( this, "ANCHOR_BOTTOM" );  -- Tooltip by button
	GameTooltip_SetDefaultAnchor(GameTooltip, this);  -- Tooltip bottom right
	
	GameTooltip:SetBagItem( MorethurQuickUse_BagNo[this:GetID()], MorethurQuickUse_SlotNo[this:GetID()]);
	
end

function MQU_HideButtonTooltip()
	GameTooltip:Hide();
end


function MQU_UpdateButtons()

	MQU_ScanInventory();

	for i = 1, 30, 1 do
		local button = getglobal("MorethurQuickUseButton" .. i);
		
		if i <= MorethurQuickUse_ItemCount then
			button:Show();
		else
			button:Hide();
		end
	end
end



function MQU_ScanInventory()

	--DEFAULT_CHAT_FRAME:AddMessage(" -Scanning inventory");
	local bag = 0;
	local slot = 0;
	
	MorethurQuickUse_ItemCount = 0;
	
    for bag=4, 0, -1 do
		local size = GetContainerNumSlots(bag);
		if (size > 0) then
			for slot=1, size, 1 do
			
				--local itemName, itemLink, itemRarity, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc  = GetContainerItemInfo(checkbag, checkslot);
				local texture, itemCount = GetContainerItemInfo(bag, slot);
				if (itemCount) then
					local link = GetContainerItemLink(bag, slot);
					
					--From KC_Items
						local _,_, code = strfind(link, "(%d+):")
					
					local itemName, itemLink, itemRarity, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc  = GetItemInfo(code);
					
					if (itemType and itemName) then  -- Prevent "nil" errors
						if ( (itemType == "Consumable" or string.find(itemName, "Bandage"))
							and MorethurQuickUse_ItemCount < 30) then
							  
							MorethurQuickUse_ItemCount = MorethurQuickUse_ItemCount + 1;
							MorethurQuickUse_BagNo[MorethurQuickUse_ItemCount] = bag;
							MorethurQuickUse_SlotNo[MorethurQuickUse_ItemCount] = slot;
							
							local button = getglobal("MorethurQuickUseButton" .. MorethurQuickUse_ItemCount);					
							local buttonText = getglobal("MorethurQuickUseButton" .. MorethurQuickUse_ItemCount .. "Text");					
							local cooldown = getglobal("MorethurQuickUseButton" .. MorethurQuickUse_ItemCount .. "Cooldown");
							local start, duration, enable = GetContainerItemCooldown(bag, slot);
							
							CooldownFrame_SetTimer(cooldown, start, duration, enable);
							
							button:SetNormalTexture(texture);
							buttonText:SetText(itemCount);
							
							--DEFAULT_CHAT_FRAME:AddMessage("itemName: " .. itemName);
							--DEFAULT_CHAT_FRAME:AddMessage("itemLink: " .. itemLink);
							--DEFAULT_CHAT_FRAME:AddMessage("itemRarity: " .. itemRarity);
							--DEFAULT_CHAT_FRAME:AddMessage("itemMinLevel: " .. itemMinLevel);
							--DEFAULT_CHAT_FRAME:AddMessage("itemType: " .. itemType);

							--DEFAULT_CHAT_FRAME:AddMessage("itemStackCount: " .. itemStackCount);
							--DEFAULT_CHAT_FRAME:AddMessage("itemEquipLoc: " .. itemEquipLoc);
							--DEFAULT_CHAT_FRAME:AddMessage(itemName .. " is consumable!");
							--DEFAULT_CHAT_FRAME:AddMessage("itemSubType: " .. itemSubType .. "\n");
						end
					end
				end
			end
		end
	end

	--DEFAULT_CHAT_FRAME:AddMessage("Found " .. MorethurQuickUse_ItemCount .. " counsumable items\n");
end

function MQU_UseItem(no)
	--DEFAULT_CHAT_FRAME:AddMessage("Button " .. no .. " clicked!");
	UseContainerItem(MorethurQuickUse_BagNo[no], MorethurQuickUse_SlotNo[no]);
	MQU_UpdateButtons();
end



-- On Drag Start event
function MQU_OnDragStart()
		this:StartMoving();
end

-- On Drag Stop event
function MQU_OnDragStop()
		this:StopMovingOrSizing();
end


function MQU_Toggle()

	if not MorethurQuickUseTop:IsVisible() then
		MorethurQuickUseTop:Show();
		MQU_UpdateButtons();
	else
		MorethurQuickUseTop:Hide();
	end

end

function MQU_OnButtonUpdate()
		if ( GameTooltip:IsOwned(this) ) then
		MQU_ShowButtonTooltip();
	end
end